{$R-}

uses screen,dos,crt;

const
  logo='L.B.A./Relentless Saved Data Editor 1.5 by KIM, JIN HONG (AROMANIX)       COREA';
  Key_Seg  = $40;
  First    = $1a;
  Last     = $1c;
  BufBegin = $80;
  BufEnd   = $82;

type
  filetype=record
    sname,fname:string;
  end;
  ScrnCell=array[1..25,1..80] of word;

var
  f:file;
  t:word;
  d:searchrec;
  filelist:array[1..12] of filetype;
  filecount:byte;
  Scrn:^ScrnCell;

procedure endprogram;
begin
  gotoxy(1,10);
  cursor(true);
  blinkattrib(true);
  halt;
end;

FUNCTION GetKey:word; assembler;
asm
   mov    ax,Key_Seg
   mov    es,ax
   xor    ax,ax
   mov    si,es:[First]
   cmp    si,es:[Last]
   je     @end
   mov    ax,es:[si]
   add    si,02
   cmp    si,es:[BufEnd]
   jb     @Ok
   mov    si,es:[BufBegin]
   @Ok:
   mov    es:[First],si
   cmp    al,224
   jne    @end
   cmp    ah,70
   jb     @end
   xor    al,al
   @end:
end;

procedure askboxdraw(t,l,b,r,c:byte);
var x,y:byte;
begin
  for y:=t to b do
    for x:=l to r do scrn^[y,x]:=word(c) shl 8 + 32;
end;

procedure askbox(top,left,bottom,right,c:byte);
var SXY:array[1..4] of byte;
    WideX,WideY,Count:byte;
begin
  SXY[1]:= Top;
  SXY[2]:= Left;
  SXY[3]:= Bottom;
  SXY[4]:= Right;

  Count :=0;
  WideX :=(Right-Left) div 10;
  WideY :=(Bottom-Top) div 10;

  if WideX=0 then WideX:=(Right-Left) div 2;
  if WideY=0 then begin
    WideY:=(Bottom-Top) div 2;
    Count:=4
  end;

  Top  := (Bottom-Top) div 2+Top;
  Left := (Right-Left) div 2+Left;

  if Top  = 0  then Top  := 1;
  if Left = 0  then Left := 1;

  Bottom  := succ(Top);
  Right   := succ(Left);

  repeat
    delay(60);
    inc(Count);

    askboxdraw(top,left,bottom,right,c);

    if Top   > SXY[1] then dec(Top,WideY);
    if Left  > SXY[2] then dec(Left,WideX);
    if Bottom< SXY[3] then inc(Bottom,WideY);
    if Right < SXY[4] then inc(Right,WideX);

    if Top   < SXY[1] then Top   := SXY[1];
    if Left  < SXY[2] then Left  := SXY[2];
    if Bottom> SXY[3] then Bottom:= SXY[3];
    if Right > SXY[4] then Right := SXY[4]
  until Count=5;

  delay(50);
  askboxdraw(top,left,bottom,right,c);
  delay(50);
  askboxdraw(SXY[1],SXY[2],SXY[3],SXY[4],c);
end;

function ask(top,mc,ti:byte;item,msg,m2:string):byte;
var
  t,i,max,c,right,m2c,left:byte;
  buf:pointer;
  ia:array[0..10] of string[15];

procedure drawbar(nf:boolean);
var c:byte;
begin
  if nf then c:=241 else c:=112;
  fprint(ia[t],left+2+(max+2)*t,top+2+m2c,c);
end;

procedure drawbarshadow;
var x:byte;
begin
  x:=left+2+(max+2)*t;
  fprint(spc(#220,max),x+1,top+3+m2c,mc);
  fprint(#220,x+max,top+2+m2c,16*mc);
end;

procedure pushenter;
var x:byte;
begin
  x:=left+2+(max+2)*t;
  fprint(ia[t],x+1,top+2+m2c,241);
  fprint(' ',x,top+2+m2c,mc*16);
  fprint(spc(' ',max),x+1,top+3+m2c,mc*16);
  delay(100);
end;

begin
  i:=0;
  ia[0]:='';
  max:=0;

  for t:=1 to length(item) do
    if item[t]=',' then begin
      if i<10 then begin
        inc(i);
        ia[i]:='';
      end;
    end else ia[i]:=ia[i]+item[t];

  for t:=0 to i do begin
    c:=length(ia[t])+ti;
    if c>max then max:=c;
  end;

  for t:=0 to i do
    ia[t]:=spc(' ',(max-length(ia[t])) div 2)+ia[t]+
           spc(' ',(max-length(ia[t])) div 2);

  left:=(79-(max+2)*(i+1)) div 2;
  right:=left+(max+2)*(i+1)+1;
  if m2='' then m2c:=0 else m2c:=2;

  savescreen(top,left,top+3+m2c,right,buf);
  askbox(top,left,top+3+m2c,right,mc*16+15);

  if msg='' then msg:='Request';
  fprint(spc(' ',right-left+1),left,top,240);
  if length(msg)>right-left+1 then msg[0]:=chr(right-left+1);
  fprint(msg,left+((right-left+1-length(msg)) div 2),top,240);

  if m2<>'' then begin
    if length(m2)>right-left+1 then m2[0]:=chr(right-left+1);
    fprint(m2,left+((right-left+1-length(m2)) div 2),top+2,mc*16+15);
  end;

  for t:=0 to i do begin
    if length(ia[t])<max then ia[t]:=ia[t]+spc(' ',max-length(ia[t]));
    drawbar(false);
    drawbarshadow;
  end;

  t:=0;
  drawbar(true);

  repeat
    c:=hi(getkey);
    if c=0 then continue;

    drawbar(false);
    case c of
      75,72:if t>0 then dec(t) else t:=i;
      77,80:if t<i then inc(t) else t:=0;
      28:begin
        pushenter;
        right:=t;
        i:=0;
      end;
    end;
    drawbar(true);

  until (c=1) or (i=0);
  if c=1 then right:=$ff;

  ask:=right;
  restorescreen(left,top,buf,true);
end;

function Num2Str(N:word):string;
var S:string;
begin
  str(N:4,S);
  Num2Str:=S
end;

procedure ControlNum(msg:string;var st:word;step,min,max:word);
var buf:pointer;
    tt,ll,bb,rr,c:byte;
begin
  tt:=11;  ll:=25;  bb:=16;  rr:=50;
  savescreen(tt,ll,bb,rr,buf);
  askbox(tt,ll,bb,rr,63);
  fprint(spc(' ',rr-ll+1),ll,tt,240);
  fprint(msg,ll+1,tt,240);
  fprint(num2str(st),ll+11,tt+3,7);
  fprint(#30'  '#30,ll+11,tt+2,63);
  fprint(#31'  '#31,ll+11,tt+4,63);
  fprint('MAX:'+num2str(max),ll+1,tt+3,48);
  fprint('MIN:'+num2str(min),ll+17,tt+3,48);

  repeat
    c:=hi(getkey);
    if c=0 then continue;

    case c of
      80:if st>min+step then dec(st,step) else st:=min;
      72:if st+step<max then inc(st,step) else st:=max;
      28:break;
    end;

    fprint(num2str(st),ll+11,tt+3,7);
  until false;

  restorescreen(ll,tt,buf,true);
end;

function Read_saved_name(fn:string):string;
var f:file;
    s:string;
begin
  assign(f,fn);
  reset(f,1);
  blockread(f,s,30);
  close(f);
  for t:=1 to 30 do
    if s[t]=#255 then begin
      s[0]:=chr(t-2);
      break
    end;
  read_saved_name:=s;
end;

procedure Find_saved_data;
begin
 FindFirst('*.LBA', Archive, D);
 filecount:=0;
 while DosError = 0 do begin
   inc(filecount);
   filelist[filecount].sname:=read_saved_name(d.name);
   filelist[filecount].fname:=d.name;
   FindNext(D);
 end;
 if filecount=0 then begin
   writeln(logo);
   writeln('DATA NOT FOUND!');
   halt;
 end;
end;

function select:byte;
var i:byte;
    c:char;
begin
  cls;
  fprint(logo,1,1,31);
  fprint('SELECT ONE TO EDIT!',20,5,7);
  for t:=1 to filecount do fprint(filelist[t].sname,20,t+6,15);
  fprint(filelist[1].sname,20,7,31);

  i:=1;
  repeat
    c:=readkey;
    if c=#0 then c:=readkey;

    fprint(filelist[i].sname,20,6+i,15);
    case c of
      #27:halt;
      #72:if i>1 then dec(i) else i:=filecount;
      #80:if i<filecount then inc(i) else i:=1;
      #13:begin
        select:=i;
        exit;
      end;
    end;
    fprint(filelist[i].sname,20,6+i,31);
  until false;
end;

procedure edit(fn:byte);
const actdata:array[0..3] of string=('Normal','Athletic','Aggressive','Discreet');
      id:array[0..1] of string=('Off','On');
var f:file;
    data:array[0..511] of byte;
    header:byte;
    c:char;

procedure status;
begin
  cls;
  reset(f,1);
  blockread(f,data,filesize(f));
  close(f);
  header:=length(filelist[fn].sname)+3;

  fprint(logo,1,1,63);
  fprint('(1) Energy          :'+num2str(data[258+header]),2,3,7);
  fprint('(2) Money           :'+num2str(data[260+header] shl 8 + data[259+header]),45,3,7);
  fprint('(3) Magic Energy Max:'+num2str(data[261+Header]),2,4,7);
  fprint('(4) Magic Energy    :'+num2str(data[262+Header]),45,4,7);
  fprint('(5) Clover Max      :'+num2str(data[263+Header]),2,5,7);
  fprint('(6) Clover          :'+num2str(data[454+Header]),45,5,7);
  fprint('(7) Action          :'+actdata[data[257+header]],2,6,7);
  fprint('(8) Boost Item!  ANCESTRAL KEY[ '+id[data[header+20]]+
         ' ] MAGIC BALL[ '+id[data[header+1]]+
         ' ] MAGIC SABER[ '+id[data[header+2]]+' ]',2,7,7);
end;

procedure setboostnf(sec:word;nf:boolean);
begin
  reset(f,1);
  seek(f,Header+sec);
  blockwrite(f,nf,1);
  close(f);
end;

procedure boost_ak;
begin
  case ask(10,5,4,'CANCEL,ON,OFF','ANCESTRAL KEY','') of
    1:setboostnf(20,true);
    2:setboostnf(20,false);
    else exit;
  end;
end;

procedure boost_mb;
begin
  case ask(10,5,4,'CANCEL,ON,OFF','MAGIC BALL','') of
    1:setboostnf(1,true);
    2:setboostnf(1,false);
    else exit;
  end;
end;

procedure boost_ms;
begin
  case ask(10,5,4,'CANCEL,ON,OFF','MAGIC SABER','') of
    1:setboostnf(2,true);
    2:setboostnf(2,false);
    else exit;
  end;
end;

procedure boostitem;
begin
  case ask(10,1,2,'CANCEL,ANCESTRAL KEY,MAGIC BALL,MAGIC SABER','What item do you want?','') of
    1:boost_ak;
    2:boost_mb;
    3:boost_ms;
    else exit;
  end;
end;

procedure action;
var b:byte;
begin
  b:=ask(10,1,2,'CANCEL,Normal,Athletic,Aggressive,Discreet','Select one','');
  if (b=0) or (b=$ff) then exit;
  reset(f,1);
  seek(f,Header+257);
  dec(b);
  blockwrite(f,b,1);
  close(f);
end;

procedure money;
var w:word;
    h,l:byte;
begin
  reset(f,1);
  seek(f,Header+259);
  blockread(f,w,2);

  controlnum('MONEY',w,9,0,999);
  h:=hi(w);
  l:=lo(w);

  seek(f,Header+259);
  blockwrite(f,l,1);
  blockwrite(f,h,1);
  close(f);
end;

procedure energy;
var w:word;
    l:byte;
begin
  reset(f,1);
  seek(f,Header+258);
  w:=0;
  blockread(f,w,1);

  controlnum('ENERGY',w,1,0,50);
  l:=lo(w);

  seek(f,Header+258);
  blockwrite(f,l,1);
  close(f);
end;

procedure magic_max;
var l:byte;
begin
  l:=ask(10,1,4,'CANCEL,0,1,2,3,4','Select MAGIC ENERGY Max','');
  if (l=0) or (l=$ff) then exit;
  dec(l);
  reset(f,1);
  seek(f,Header+261);
  blockwrite(f,l,1);
  close(f);
end;

procedure magic;
var w:word;
    l:byte;
begin
  reset(f,1);
  seek(f,Header+262);
  w:=0;
  blockread(f,w,1);

  controlnum('MAGIC ENERGY',w,1,0,80);
  l:=lo(w);

  seek(f,Header+262);
  blockwrite(f,l,1);
  close(f);
end;

procedure clover_max;
var w:word;
    l:byte;
begin
  reset(f,1);
  seek(f,Header+263);
  w:=0;
  blockread(f,w,1);

  controlnum('CLOVER MAX',w,1,0,10);
  l:=lo(w);

  seek(f,Header+263);
  blockwrite(f,l,1);
  close(f);
end;

procedure clover;
var w:word;
    l:byte;
begin
  reset(f,1);
  seek(f,Header+454);
  w:=0;
  blockread(f,w,1);

  controlnum('CLOVER',w,1,0,10);
  l:=lo(w);

  reset(f,1);
  seek(f,Header+454);
  blockwrite(f,l,1);
  close(f);
end;

begin
  assign(f,filelist[fn].fname);
  status;

  repeat
    case ask(10,2,2,'1,2,3,4,5,6,7,8,End','Select menu you want to edit','') of
      0:energy;
      1:money;
      2:magic_max;
      3:magic;
      4:clover_max;
      5:clover;
      6:action;
      7:boostitem;
      else halt;
    end;

    status;
  until false;
end;

begin
  find_saved_data;
  cursor(false);
  blinkattrib(false);
  exitproc:=@endprogram;
  if mem[$000:$449]=7 then Scrn:=ptr($B000,0) else Scrn:=ptr($B800,0);
  edit(select);
end.
